# This one does SCC in O(V^2 + E) time
import math
import sys
sys.setrecursionlimit(10000)

(n, m, k) = map(int, raw_input().split())
I = [map(int, raw_input().split()) for _ in range(n)]

adj = [[0]*n for _ in range(n)]
dst = [0]*n
for _ in range(m):
    (x, y, h) = map(int, raw_input().split())
    src = 0
    dsts = 0
    for i in range(n):
        (xx, yy, r) = I[i]
        if (x-xx)**2 + (y-yy)**2 < r**2:
            src = i
        elif (x-xx)**2 + (y-yy)**2 <= (r+h*k)**2:
            dst[dsts] = i
            dsts += 1
    for d in range(dsts):
        adj[src][dst[d]] = 1

depth = [0]*n
par = [0]*n

def dfs(u, d):
    depth[u] = d
    ans = u
    for v in range(n):
        if adj[u][v]:
            if not depth[v]:
                v = dfs(v, d+1);
            else:
                while depth[v] == 1<<30 and v != par[v]:
                    v = par[v]
            if depth[v] < depth[ans]:
                ans = v
    depth[u] = 1<<30
    par[u] = ans
    return ans

root = [0]*n
for i in range(n):
    if not depth[i]:
        dfs(i, 1);
    r = i
    while par[r] != r:
        r = par[r]
    root[i] = r


src = [True]*n
sink = [True]*n
for i in range(n):
    for j in range(n):
        if root[j] != root[i]:
            if adj[i][j]:
                sink[root[i]] = False
            if adj[j][i]:
                src[root[i]] = False

Crit = [i for i in range(n) if root[i] == i and (src[i] or sink[i])]

if len(Crit) > 2:
    print 'impossible'
elif len(Crit) < 2:
    print '0'
else:
    (u, v) = list(Crit)
    res = min(math.sqrt((I[i][0]-I[j][0])**2 + (I[i][1]-I[j][1])**2) - I[i][2] - I[j][2] + 100 + 100
              for i in range(n) if root[i] == u
              for j in range(n) if root[j] == v)
    print res
